import { MethodInjection, PropertyInjection, PropertyValueInjection } from './src/injection';
import { MemoryLifetime, TransientLifetime } from './src/lifetime';
import { Constructor } from './src/types';
export * from './src/container';
export * from './src/object-builder';
export * from './src/types';
export * from './src/lifetime';
export * from './src/injection';
export declare const inject: {
    propertyValue: <TType = unknown>(propertyName: keyof TType & string, value: unknown) => PropertyValueInjection<TType, unknown>;
    property: <T = unknown>(propertyName: keyof T & string, valueKey: string | Constructor<T>) => PropertyInjection<T>;
    method: <T_1 = unknown>(methodName: keyof T_1 & string, args?: unknown[] | null) => MethodInjection<T_1>;
};
export declare const lifetime: {
    transient: () => TransientLifetime;
    memory: () => MemoryLifetime;
};
